/*****************************************************************/
/*                                                               */
/* MODULE: Ramka.c                                               */
/* FUNCTIONALITY: Program na laboratoria GRAFIKA KOMPUTEROWA     */
/* Copyright (C) 2001 by Piotr M. Szczypinski                    */
/*                                                               */
/*****************************************************************/

#include <windows.h>
#include "ramka.h"

#pragma argsused
int PASCAL WinMain( HANDLE zadan, HANDLE ppzad, LPSTR parwyw, int stanokna )
{
  MSG komunikat;
  HWND okno;
  HMENU menu;

  if( !ppzad )
  {
    WNDCLASS klasaokna;
    klasaokna.style         = NULL;
    klasaokna.lpfnWndProc   = WinProc;
    klasaokna.cbClsExtra    = 0;
    klasaokna.cbWndExtra    = 0;
    klasaokna.hInstance     = zadan;
    klasaokna.hIcon         = LoadIcon( zadan, "ICONR" );
    klasaokna.hCursor       = LoadCursor(NULL, IDC_ARROW);
    klasaokna.hbrBackground = NULL;
    klasaokna.lpszMenuName  = NULL;
    klasaokna.lpszClassName = "RAMKA";
    if(!RegisterClass(&klasaokna)) return FALSE;
  }
  else return -1;

  menu= LoadMenu(zadan, "MENUR");
  okno= CreateWindow( "RAMKA", "Grafika Komputerowa - laboratorium",
             WS_OVERLAPPEDWINDOW,
             CW_USEDEFAULT, CW_USEDEFAULT,
             CW_USEDEFAULT, CW_USEDEFAULT,
             NULL, menu, zadan, NULL );

  if ( !okno ) return FALSE;
  ShowWindow( okno, stanokna );
  UpdateWindow( okno );

  while( GetMessage( &komunikat, NULL, 0, 0 ) )
  {
    TranslateMessage( &komunikat );
    DispatchMessage( &komunikat );
  }
  DestroyMenu(menu);
  return komunikat.wParam;
}

/*------------------------------------------------------------
                 Procedura obslugi zdarzen*/
long WINAPI WinProc( HWND okno, UINT kmnk, WPARAM wparam, LPARAM lparam )
 {
   HDC kontekst;
   PAINTSTRUCT struktrys;
   RECT prost;
   HBRUSH brush;
   HGDIOBJ old_sel;

   switch ( kmnk )
   {
     case WM_DESTROY:
       PostQuitMessage(0);
     return 0;

     case WM_PAINT:
       kontekst=BeginPaint( okno, &struktrys );

       brush=CreateSolidBrush(GetSysColor(COLOR_WINDOW ));
       old_sel=SelectObject(kontekst,brush);
       GetClientRect(okno, &prost);
       Rectangle(kontekst, prost.left-1, prost.top-1,
                           prost.right+1, prost.bottom+1);
       SelectObject(kontekst,old_sel);
       DeleteObject(brush);

       Rysuj(kontekst);
       EndPaint( okno, &struktrys );
     break;

     case WM_COMMAND:
     switch (wparam)
     {
       case MEN_A:
         OpcjaA();
       return 0;

       case MEN_B:
         OpcjaB();
       return 0;

       case MEN_C:
         OpcjaC();
       return 0;

       case MEN_D:
         OpcjaD();
       return 0;

       case MEN_EXIT:
         SendMessage(okno, WM_CLOSE, 0, 0L);
       return 0;

       default:break;
     }
   }
   return DefWindowProc( okno, kmnk, wparam, lparam );
 }

